import { MatDialogRef, MAT_DIALOG_DATA } from "@angular/material";
import { Inject, Component } from "@angular/core";

import { I18nService } from "../../services/internationalisation/internationalisation.service";
import { FormBuilder } from "@angular/forms";

@Component({
    selector: "dialog-generate-pab",
    templateUrl: "dialog-generate-pab.component.html",
    styleUrls: ["dialog-generate-pab.component.scss"]
})
export class DialogGeneratePABComponent {

  public debit = 1.5;

  public coteAmont = 102;

  public chute: number;

  public nbBassins = 6;

  constructor(
    public dialogRef: MatDialogRef<DialogGeneratePABComponent>,
    private intlService: I18nService,
    private fb: FormBuilder,
    @Inject(MAT_DIALOG_DATA) public data: any
  ) {
    this.coteAmont = data.coteAmont;
    this.debit = data.debit;
    this.chute = data.chute;
  }

  public generatePAB() {
    // calculate downstream elevation
    const coteAval = this.coteAmont - (this.chute * this.nbBassins);
    // create PAB
    this.dialogRef.close({
      generate: true,
      debit: this.debit,
      coteAmont: this.coteAmont,
      coteAval: coteAval,
      nbBassins: this.nbBassins
    });
  }

  public get uitextDebit() {
    return this.intlService.localizeText("INFO_DIALOG_PAB_Q");
  }

  public get uitextCoteAmont() {
    return this.intlService.localizeText("INFO_DIALOG_PAB_Z1");
  }

  public get uitextCoteAval() {
    return this.intlService.localizeText("INFO_DIALOG_PAB_Z2");
  }

  public get uitextNBBassins() {
    return this.intlService.localizeText("INFO_DIALOG_PAB_NB");
  }

  public get uitextMustBeANumber() {
    return this.intlService.localizeText("ERROR_PARAM_MUST_BE_A_NUMBER");
  }

  public get uitextMustBePositive() {
    return this.intlService.localizeText("ERROR_PARAM_MUST_BE_POSITIVE");
  }

  public get uitextGeneratePAB() {
      return this.intlService.localizeText("INFO_CALCULATOR_RESULTS_GENERATE_PAB");
  }

  public get uitextGenerate() {
    return this.intlService.localizeText("INFO_OPTION_GENERATE");
  }

  public get uitextCancel() {
    return this.intlService.localizeText("INFO_OPTION_CANCEL");
  }
}
