import { Component } from "@angular/core";

import { cLog, Message } from "jalhyd";

import { I18nService } from "../../services/internationalisation/internationalisation.service";

@Component({
    selector: "log",
    templateUrl: "./log.component.html",
    styleUrls: [
        "./log.component.scss"
    ]
})
export class LogComponent {
    /**
     * journal
     */
    private _log: cLog;

    constructor(
        private intlService: I18nService,
    ) { }

    private get uitextTitreJournal() {
        return this.intlService.localizeText("INFO_TITREJOURNAL");
    }

    public get hasEntries(): boolean {
        return this._log !== undefined && this._log.messages.length !== 0;
    }

    private get messages(): Message[] {
        return this._log.messages;
    }

    public set log(log: cLog) {
        this._log = log;
    }
}
