import { Component, Input } from "@angular/core";

import { SelectField } from "../../formulaire/select-field";
import { SelectEntry } from "../../formulaire/select-entry";

@Component({
    selector: "select-field-line",
    templateUrl: "../generic-select/generic-select.component.html",
    styleUrls: [
        "./select-field-line.component.scss"
    ]
})
export class SelectFieldLineComponent {
    @Input()
    private _select: SelectField;

    public get selectId() {
        return this._select.id;
    }

    public get entries(): SelectEntry[] {
        if (! this._select) {
            return [];
        }
        return this._select.entries;
    }

    protected entryLabel(entry: SelectEntry): string {
        return entry.label;
    }

    public get selectedValue(): SelectEntry {
        return this._select.getValue();
    }

    public set selectedValue(v: SelectEntry) {
        this._select.setValue(v);
    }

    public get label() {
        if (this._select) {
            return this._select.label;
        } else {
            return "";
        }
    }
}
