import { Structure, ParamDefinition } from "jalhyd";

import { FormComputeFixedVar } from "./form-compute-fixedvar";
import { FormResultFixedVar } from "./form-result-fixedvar";
import { FormulaireDefinition } from "./form-definition";

export class FormComputeParallelStructures extends FormComputeFixedVar {

    constructor(formBase: FormulaireDefinition, formResult: FormResultFixedVar) {
        super(formBase, formResult);
    }

    /**
     * construit un identifiant de type { uid: "abcdef", symbol: "X" }
     * avec "abcdef" l'index de l'ouvrage et "X" son paramètre
     */
    protected getParameterRefid(p: ParamDefinition): any {
        const nub = p.parentComputeNode;
        if (nub instanceof Structure) {
            return {
                uid: nub.uid,
                symbol: p.symbol
            };
        } else {
            return super.getParameterRefid(p);
        }
    }
}
